from gi.repository import Gio
from desktop import DesktopParser
from mainwindow import MainWindow
from utils import get_icon, nullstring
import os
from gobject import GError

class AppGUI:
    """XXX: add docs."""

    def __init__(self):
        """Display the main window."""
        
        self.gsettings = Gio.Settings('com.canonical.Unity.Launcher')
        self.main_window = MainWindow(self)
        self.main_window.show()
        self.get_unit_list()
        return

    def save_unity_list(self, menu_items):
        try:
            print str(menu_items)
            self.gsettings.set_strv('favorites',menu_items)
        except GError,e:
            print e
        #return_code = os.system('unity --reset') #subprocess.call(['unity','--reset'])
        #if return_code != 0:
        #    print "Settings fail to transition to new unity compiz favorites"
        
    def get_unit_list(self):
        """ Create a list of items from unity's Launcher Panel."""

        unity = self.gsettings.get_value('favorites')
        store = self.main_window.listview_launcher.get_model()
        store.clear()
        print unity
        for menu_item in unity:
            desktop_parser = DesktopParser(menu_item)
            desktop_parser.update_keys()
            sname = desktop_parser.get('Name')
            icon = desktop_parser.get('Icon')
            if sname is None:
                sname = desktop_parser.get('Name', 'en')
            if icon is None:
                pix = None
            else:
                pix = get_icon(icon)
            store.append((pix, '%s' % sname, desktop_parser, menu_item))
            print sname, menu_item

        self.main_window.listview_launcher.set_model(store)
        self.main_window.listview_launcher.connect('cursor-changed',
            self.main_window.listview_launcher_row_change)
        #make first row active
        self.main_window.listview_launcher.set_cursor((0,))


